package org.netkernel.mod.architecture;

import org.netkernel.ext.system.representation.IRepDeployedModules;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.urii.SimpleIdentifierImpl;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.urii.IIdentifier;
import org.netkernel.urii.ISpace;
import org.netkernel.urii.impl.Version;

public class SpaceVersionToHashRedirectAccessor	extends StandardAccessorImpl
{
	public SpaceVersionToHashRedirectAccessor()
	{	this.declareThreadSafe();
	}

	@Override
	public void onSource(INKFRequestContext aContext) throws Exception
	{	
		IHDSNode p=aContext.source("httpRequest:/params", IHDSNode.class);
		IIdentifier sid=new SimpleIdentifierImpl((String)p.getFirstValue("//space"));
		Version v=new Version((String)p.getFirstValue("//version"));
		ISpace space=aContext.getKernelContext().getKernel().getSpace(sid, v, v);
		IRepDeployedModules mods=aContext.source("active:moduleList", IRepDeployedModules.class);
		String hash=mods.hashForComponent(space);
		INKFResponse resp=aContext.createResponseFrom("");
		resp.setHeader("httpResponse:/redirect", "/tools/ae/view/moduleDetails/"+hash);
	}
}
