package tools.exceptionHandler;

import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.xml.xda.IXDAReadOnly;

public class BEFExceptionHandler extends StandardAccessorImpl
{
	public BEFExceptionHandler()
	{	this.declareThreadSafe();
	}
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		IXDAReadOnly ex=aContext.source("arg:operand",IXDAReadOnly.class);
		
		INKFRequest req=aContext.createRequest("active:xslt");
		req.addArgument("operator","res:/nkse/style/xsl/format_exception.xsl");
		req.addArgumentByValue("operand",ex);
		INKFResponseReadOnly respIn=aContext.issueRequestForResponse(req);
		INKFResponse resp=aContext.createResponseFrom(respIn);

		String id="Unknown Error";
		String msg="";
		try
		{	id=ex.getText("(descendant-or-self::ex[id])[last()]/id",true);
			msg=ex.getText("(descendant-or-self::ex[id])[last()]/message",true);
		}
		catch (Exception e) {;}
		
		resp.setHeader("WrappedControlPanel", id);
		resp.setHeader("WrappedControlPanelSubtitle", msg);
		resp.setHeader("WrappedControlPanelIcon", "/nkse/style/img/exception.png");
	}

}
