package tools.news;

import org.netkernel.layer0.nkf.*;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class NewsDataFast extends StandardAccessorImpl implements INKFAsyncRequestListener
{
	INKFResponseReadOnly<Object> mLastResponse;
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		if (mLastResponse!=null)
		{	aContext.createResponseFrom(mLastResponse);
		}
		else
		{ 
			String emptyFeed="<atom:feed xmlns:atom='http://www.w3.org/2005/Atom'/>";
			INKFResponse response=aContext.createResponseFrom(emptyFeed);
			response.setExpiry(INKFResponse.EXPIRY_CONSTANT,System.currentTimeMillis()+10000);
		}
		
		if (mLastResponse==null || mLastResponse.isExpired())
		{		INKFRequest req=aContext.createRequest("res:/tools/newsData");
				aContext.issueAsyncRequest(req).setListener(this);
		}
	}

	@Override
	public void receiveResponse(INKFResponseReadOnly aResponse, INKFRequestContext aContext) throws Exception
	{	mLastResponse=aResponse;
		aContext.setNoResponse();
	}

	@Override
	public void receiveException(NKFException aException, INKFRequest aRequest, INKFRequestContext aContext) 	throws Exception
	{	aContext.setNoResponse();
	}

}
