<?xml version="1.0" encoding="UTF-8" ?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="xml"/>
  <xsl:param name="param"/>
  <xsl:param name="config"/>
  
  <xsl:variable name="explorer">/tools/explore/</xsl:variable>

  <xsl:include href="res:/nkse/style/xsl/format_resolution.xsl"/>	


  <xsl:template match="/" xmlns:xrl="http://netkernel.org/xrl" >
    <div style="min-height: 600px;">
	  <script type="text/javascript"><xsl:comment>
	  <![CDATA[
	  function doExec()
	  {	type=$("#radio input:radio:checked").val();
	  	if(type=="representation")
	  	{
	  		document.form1.action="/tools/requesttrace";
	  		document.form1.action1.value='display';
			document.form1.submit();
		}
		else
		{	doRequest('execute');
		}
	  }
	  function doRequest(name)
	  {	
	  		document.form1.action="";
	  		document.form1.action1.value=name;
	  		document.form1.submit();
	  	
	  }
	  enableTextareaTab("requestbox");
	 
	function doSubmit(name)
	  {	document.form1.action="";
	  		document.form1.action1.value=name;
	  		document.form1.submit();
	  } 
	function prefill()
	{	$("#requestbox").val("<request>\n\t<identifier></identifier>\n\t<argument name=\"\"></argument>\n</request>");
	}
	
	function spaceExplorerSpace()
	{	hash=$("#spaceSelect").val();
		window.location='/tools/ae/view/spaceDetails/'+hash;
	}
	function spaceExplorerModule()
	{	hash=$("#spaceSelect").val();
		window.location='/tools/ae/view/moduleDetails/'+hash.split("/")[0];
	}
	function traceClasspath()
	{	hash=$("#spaceSelect").val();
		window.location='/tools/classtrace?class=&module='+hash.split("/")[0];
	}
	
	]]>
	  </xsl:comment></script>
	  
		<xrl:include>
			<xrl:identifier>active:controlPanelInfoBox</xrl:identifier>
			<xrl:argument name="content">
				<div>
          <p>
            The Request Resolution Trace tool will create and inject a resource request
            into a specified space with a specified resource identifier and request verb.
          </p>
          <p>
            To configure a request trace:
          </p>
          <ul>
            <li>Select a module (This will populated the Space drop down list)</li>
            <li>Select a space.</li>
            <li>Enter the resource identifier or declarative request</li>
            <li>Select a request verb.</li>
          </ul>
          <p>
            To issue the request trace click on the button labeled:
          </p>
          <ul>
            <li>"Resolve" to determine if the request resolves to an endpoint.</li>
            <li>"Execute" will issue the request for execution by the endpoint.  The displayed result will either be the Response (default) or the Representation.</li>
          </ul>
				</div>
			</xrl:argument>
		</xrl:include>
	  
	  
	  
      
      	<div class="row">
			<div class="col-md-8">
				<form name="form1" method="get">
				<table class="table" border="0" width="100%">
        
          <!-- Module Selection Row -->
          <tr>
            <td class="label">Module:</td>
            <td>
              <select name="module" onchange="doSubmit('')">
                <xsl:for-each select="/modules/module">
                  <xsl:sort select="id"/>
                  <option>
                    <xsl:attribute name="value">
                      <xsl:value-of select="hash"/>
                    </xsl:attribute>
                    <xsl:if test="$param/resolve/module/text()=hash">
                      <xsl:attribute name="selected">true</xsl:attribute>
                    </xsl:if>
                    <xsl:value-of select="id"/> - <xsl:value-of select="version"/>
                  </option>
                </xsl:for-each>
              </select>
            </td>
          </tr>

          <tr>
            <td class="label">Space:</td>
            <xsl:variable name="module">
            	<xsl:choose>
            		<xsl:when test="$param/resolve/module/text()"><xsl:value-of select="$param/resolve/module/text()"/></xsl:when>
            		<xsl:otherwise>
            			<xsl:for-each select="/modules/module">
                  			<xsl:sort select="id"/>
                  			<xsl:if test="position()=1"><xsl:value-of select="hash"/></xsl:if>
                  		</xsl:for-each>
            		</xsl:otherwise>
            	</xsl:choose>
            </xsl:variable>
            <td>
              <select id="spaceSelect" name="space">
                <xsl:for-each select="/modules/module[hash=$module]/spaces/space">
                	<xsl:call-template name="space-option"/>
                </xsl:for-each>
              </select>
            </td>
          </tr>

          <tr>
            <td class="label">Identifier /<br/>Declarative Request:</td>
            <td>
              <textarea id="requestbox" type="text" name="uri" style="width:40em; height: 7em;">
                  <xsl:value-of select="$param/resolve/uri"/>
              </textarea>
              
              
            </td>
            
          </tr>
          <tr>
            <td class="label">Verb:</td>
            <td>
            	<select name="verb">
            		<option value="1">
	                    <xsl:if test="$param/resolve/verb/text()='1'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>
            			SOURCE
            		</option>
            		<option value="2">
	                    <xsl:if test="$param/resolve/verb/text()='2'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>
            			SINK
            		</option>
            		<option value="4">
	                    <xsl:if test="$param/resolve/verb/text()='4'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>
            			EXISTS
            		</option>
            		<option value="8">
	                    <xsl:if test="$param/resolve/verb/text()='8'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>
            			DELETE
            		</option>
            		<option value="16">
	                    <xsl:if test="$param/resolve/verb/text()='16'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>
            			NEW
            		</option>
            		<option value="256">
	                    <xsl:if test="$param/resolve/verb/text()='256'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>
            			META
            		</option>
            	</select>
            	
            	<span style="margin-left: 10px; font-size: 80%"><a class="btn btn-default" href="javascript:prefill()">Declarative Request Template</a></span>
            </td>
          </tr>

          <tr>
            <td/>
            <td>
            		<div id="radio">
            			<input type="hidden" name="action1"/>
            			<input class="btn btn-primary" value="Resolve" type="button" onclick="doRequest('resolve')"/>
            			<input class="btn btn-primary" style="margin-left: 10px; margin-right: 5px;" value="Execute" type="button" onclick="doExec()"/>
						<input name="resulttype" value="response" type="radio" checked="true">Response</input>
						<input name="resulttype" value="representation" type="radio">Representation</input>
					</div>
            </td>
           </tr>

          <xsl:apply-templates select="$param/resolve/resolution"/>
          <xsl:apply-templates select="$param/resolve/response"/>
       
          
        </table>	
        </form>
			</div>
			<div class="col-md-4">
			<div class="pull-right panel panel-default">
			  	<div class="panel-heading">
			  		<div class="panel-title"><img src="/tools/ae/pub/icon.png" style="width: 24px; margin-right: 5px;"/>Explore</div>
			  	</div>
			  	<div>
			  	<a class="btn btn-default" href="javascript:spaceExplorerSpace();" style="width: 10em; margin: 2px;">View Space</a>
			  	</div>
			  	<div>
			  	<a class="btn btn-default" href="javascript:spaceExplorerModule();" style="width: 10em;  margin: 2px;">View Module</a>
			  	</div>
			  	<div>
			  	<a class="btn btn-default" href="javascript:traceClasspath();" style="width: 10em; margin: 2px;">Trace Classpath</a>
			  	</div>
	  </div>
			</div>      	
      	</div>
        
      
    </div>
  </xsl:template>
  
  <xsl:template match="resolution">
      <tr>
         <td colspan="2">
           <hr/>
         </td>
       </tr>
       <tr>
         <td class="label">Physical Endpoint:</td>
         <td class="pseudo-input">
           <div>
           	<a href="{$explorer}{physicalHash}">
           		<xsl:value-of select="toString"/>
           	</a>
           	</div>
         </td>
       </tr>

       <tr>
         <td class="label">Logical Endpoint:</td>
         <td class="pseudo-input">
           <div>
           	<a href="{$explorer}{logicalHash}">
           		<xsl:value-of select="id"/>
           	</a>
           </div>
         </td>
       </tr>
       <tr>
         <td class="label">Resolved Scope:</td>
         <td class="pseudo-input">
         	<xsl:for-each select="scope/level">
         		<div>
         			<a href="{$explorer}{hash}">
         				<xsl:value-of select="space"/>
         			</a>
         		</div>
         	</xsl:for-each>
         </td>
       </tr>
       <tr>
         <td class="label">Resolution Trace:</td>
         <td class="pseudo-input">
         	<xsl:for-each select="trace">
         		<xsl:call-template name="resolution"/>
         	</xsl:for-each>
         </td>
       </tr>
  </xsl:template>
  
	<xsl:template name="space-option">
		<xsl:param name="indent"></xsl:param>
		<option>
			<xsl:attribute name="value">
				<xsl:value-of select="hash"/>
			</xsl:attribute>
			<xsl:if test="$param/resolve/space/text()=hash">
				<xsl:attribute name="selected">true</xsl:attribute>
			</xsl:if>
			<xsl:value-of select="$indent"/><xsl:value-of select="name"/>
		</option>
		<xsl:for-each select="spaces/space">
			<xsl:call-template name="space-option">
				<xsl:with-param name="indent"><xsl:value-of select="$indent"/>&#160;&#160;</xsl:with-param>
			</xsl:call-template>
		</xsl:for-each>
	</xsl:template> 
	
	
	<xsl:template match="response">
      <tr>
         <td colspan="6">
           <hr/>
         </td>
       </tr>
		<tr>
			<td class="label">Representation Type:</td>
			<td class="pseudo-input">
				<xsl:choose>
					<xsl:when test="repHash">
						<a href="{$explorer}{repHash}">
							<xsl:value-of select="repName"/>
						</a> (<xsl:value-of select="repClass"/>)
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="repClass"/>
					</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
		<tr>
			<td class="label">Representation toString():</td>
			<td colspan="5" style="border: solid 1px black; background: white;">
				<pre><xsl:value-of select="repToString"/></pre>
			</td>
		</tr>
		<tr>
			<td class="label">Expiry Determinants:</td>
			<td class="pseudo-input">
				<xsl:for-each select="expiry/e">
					<xsl:call-template name="expiry"/>
				</xsl:for-each>
			</td>
		</tr>
		<tr>
			<td class="label">IsExpired?:</td>
			<td class="pseudo-input">
				<xsl:value-of select="isExpired"/>
			</td>
		</tr>
		<tr>
			<td class="label">Cost:</td>
			<td class="pseudo-input">
				<xsl:value-of select="cost"/>
			</td>
		</tr>
		
		<tr>
			<td class="label">Response Fields:</td>
			<td class="pseudo-input">
				<xsl:choose>
					<xsl:when test="usermeta/value">
						<xsl:for-each select="usermeta/value">
							<xsl:variable name="class">
								<xsl:choose>
									<xsl:when test="position() mod 2 = 0">
										<xsl:text>evenrow</xsl:text>
									</xsl:when>
									<xsl:otherwise>
										<xsl:text>oddrow</xsl:text>
									</xsl:otherwise>  
								</xsl:choose>
							</xsl:variable>							
							<div class="{$class}">
								<xsl:choose>
									<xsl:when test="@key='ad'">
										[Additional dependencies on locally cached responses]
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="key"/> = <xsl:value-of select="text()"/>
									</xsl:otherwise>
								</xsl:choose>
								
							</div>
						</xsl:for-each>
					</xsl:when>
					<xsl:otherwise>none</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
		
	</xsl:template>
	
	<xsl:template name="expiry">
		<div>
			
			<xsl:value-of select="@exp"/>
			<xsl:value-of select="@msg"/>
			<xsl:if test="e">
				<div style="margin-left: 1em;">
				<xsl:for-each select="e">
					<xsl:call-template name="expiry"/>
				</xsl:for-each>
				</div>
			</xsl:if>
		</div>
	</xsl:template>		
	

</xsl:stylesheet>
